--package.path = package.path .. ";../?/init.lua;../?.lua"

-- preload
-- for loading all files required before beginning the game state machine
-- as well as for procesing any command line args (if implemented)
-- and initializing things
preload = {}

require "EntityFactory"

require "attributes.GameStateAttribute"
require "util.fez.ControllerManager"
require "util.fez.EntityManager"
require "util.fez.EntityTagManager"
require "util.fez.EventDispatcher"
require "util.fez.AspectManager"
require "util.fez.Component"
require "util.fez.ComponentCache"
require "controllers.MapController"
require "renderers.MapRenderer"
require "MapLoader"


function preload.init()
  math.randomseed(os.time())
  
  entityManager = EntityManager()
  controllerManager = ControllerManager()
  
	game   = createGame()
	gameState = entityManager:getComponentFromEntity( game, GameStateAttribute )
  
	mapController = MapController( controllerManager )
  mapRenderer = MapRenderer( controllerManager )
  mapLoader = MapLoader()
  
  MapLoader:load( 'resources/levels/level1.lua' )
  controllerManager:refresh()
end

return preload